

typedef struct muffetnode muffetnode;
typedef struct muffetchild muffetchild;
typedef struct muffetbody muffetbody;
typedef struct muffetlink muffetlink;
typedef struct muffet_inc_ref muffet_inc_ref;
typedef struct muffet_out_ref muffet_out_ref;
typedef struct muffettag muffettag;


typedef enum muffet_type{
	o_HUB = 0,
	o_ARTICLE,
	o_TEXT,
	o_TAG,
	o_PORTFOLIO,
	o_ALBUM,
	o_LITERAL,
	o_FEED,
//	o_TEXTPORTAL, //depreciated -> articles
	o_OTHER,
	o_ERROR
}muffet_type;

typedef enum muffet_reftype{
	r_INTERN = 0,
	r_IMG,
	r_SOUND,
	r_VIDEO,
	r_FILE,
	r_TXT,
	r_HTML,
	r_LIST,
	r_ARCHIVE,
	r_YOUTUBE,
	r_HTTP,
	r_GEMINI,
	r_BANDCAMP,
	r_PROTOCOL,
	r_ERROR
}muffet_reftype;
/*
switch(r->type){
	case r_INTERN:
	case r_IMG:
	case r_SOUND:
	case r_VIDEO:
	case r_TXT:
	case r_HTML:
	case r_LIST:
	case r_ARCHIVE:
	case r_YOUTUBE:
	case r_HTTP:
	case r_BANDCAMP:
	case r_PROTOCOL:
	case r_ERROR:
	default:
}
*/

extern char * muffet_type_str[];
extern char * muffet_reftype_str[];

extern muffet_type getmuffettype(char *);
extern muffet_reftype getreftype(char *);

extern void printmuffetchild(Avl *n, Biobuf *in, int out, int dir);
extern void printmuffetbody(Avl *n, Biobuf *in, int out, int dir);
extern void printmuffetnode(Avl *n, Biobuf *in, int out, int dir);

extern void freemuffetnode(Avl * n);
extern void freemuffetchild(Avl * n);
extern void freemuffetbodyline(Avl * n);
extern void freemuffetlink(Avl * n);
extern void freemuffet_inc_ref(Avl * n);
extern void freemuffet_out_ref(Avl * n);
extern void freemuffettag(Avl * n);


typedef struct muffetnode{
	Avl;
	char *name;
	char *host;
	char *bref;
	muffet_type type; 
	
	Avltree *children;
	Avltree *bodylines; //uses tree in maintree node where lnode->name == BODY -> litree
	Avltree *links;
	Avltree *inc_refs;
	Avltree *out_refs;
	Avltree *tags;
} muffetnode;

typedef struct muffetchild{
	Avl;
	char		*name;
	muffetnode	*node;
} muffetchild;

typedef struct muffetbody{
	Avl;
	int index;
	char *line;
	char ** refs;
	char ** parts;
	int refcount;
} muffetbody;

typedef struct muffetlink{
	Avl;
	int		index;
	char	*name;
	char	*url;
	char	*desc;
} muffetlink;

typedef struct muffet_inc_ref{
	Avl;
	char	  	*name;
	muffetnode	*node;
} muffet_inc_ref;

typedef struct muffet_out_ref{
	Avl;
	int		index;
	char	*name;
	char	*text;
	char	*desc;
	muffet_reftype type;
	
} muffet_out_ref;

typedef struct muffettag{
	Avl;
	char 		*name;
	muffetnode 	*node;
} muffettag;


typedef struct tagcountnode{
	int		count;
	char	*name;
} tagcountnode;






void freemuffetnode(Avl * n);
void freemuffetchild(Avl * n);
void freemuffetbody(Avl * n);
void freemuffetlink(Avl * n);
void freemuffet_inc_ref(Avl * n);
void freemuffet_out_ref(Avl * n);
void freemuffettag(Avl * n);

